; -- DATA SEGMENT --

; Keys being pressed
moveshootkeys		db	0
otherkeys		db	0

; HUD text
wavestr			db	'Wave ',0
quitstr			db	'Really quit?',0

; Game flags
; 1 = player death
; 2 = wave clear
; 4 = player's bomb exploding
; 8 = wave time expired
gflags			db	0

; Other sound-related variables
sflags			db	0
stimer			db	0	; Sound timer
sfreq			dw	0	; Frequency (division of PIT_FREQ in equate)

; Internal game timers (certain events can be triggered)
gtimer			dw	0
oldtimer		dw	0
timeout			db	0

; Title screen strings
gname			db 	'T H E  F I R S T  C E L L',0
tstr1			db 	' Microscopic commando action',10
			db	'starring you (',PLAYER_CH,'), the "player"',0

tstr10			db	'The Controls:',0
tstr11			db	'WASD to shoot, arrow keys to move',10
			db	'Space to detonate a bomb',10
			db	'P to pause, Esc to exit',10
			db	'M to mute/unmute sound',0

tstr20			db	'Bonus MAN every 10,000 points',0

tstr30			db	'Press valid key to begin simulation...',0

version_str		db	'v1.0a',0	; Version number

exitstr			db	'ELECTRONIC CARNAGE CONTINUES AT razorback95.com',13,10,'$'

; Game over-related strings
result_str		db	'Cell result:',0
defective_str		db	'DEFECTIVE',0
potential_str		db	'POTENTIAL',0
optimal_str		db	'OPTIMAL',0
perfect_str		db	'PERFECT!!',0
endmsg_str		db	'Esc to terminate,',10
			db	'any other key to retry',0

; Wave strings are in another file
include 'messages.asm'

; Random pregenerated numbers used by enemy objects
rindex			dw	0	
include			'random.asm'

; Static enemy data for each wave
include			'enemies.asm'
include			'waves.asm'

; Embed this string in here to be sure.
license			db	'The First Cell is released under a CC0 license.',0

; Player's attributes (initialized to default values)
score			dd	?
auxscore		dw	?	; for extra lives
lives			db	?
bombs			db	?
wave			db	?
wave_time		dw	?	; if passed, spawn garbage enemies
player_x		db	?
player_y		db	?

; When enemies are destroyed, new ones must take their place when
; the system timer hits a certain tick, until this counter hits
; zero. A new enemy MUST spawn far from the player!
equeue			db	?
eremain			db	?
eindex			dw	?

; More timeout mode variables
etcount			db	?
etindex			dw	?	; Index for timeout mode

; Attributes of enemies and projectiles
; 1 = Character
; 2 = Color
; 3 = X Position
; 4 = Y Position
; 5 = Auxiliary Halfbyte/Direction
; 6 = Ticks to Move/Current Ticks (halfbytes)
; 7 = Hits to Take
; 8 = Type (alternatively, 7 and 8 hold SI for the worm head)

pbullet			db	PBULLET_CT*OBJ_LEN dup ?
pbomb_timer		db	?
pbomb_timer2		db	?
pbomb			db	PBOMB_DATA_LEN*OBJ_LEN dup ?
pbomb_end = $

; Enemy attributes stored in doublewords.
; Up to 16 enemies can exist on the screen at once, as defined by ENEMY_CT.
eattr			db	ENEMY_CT*OBJ_LEN dup ?
eattr_end = $

; Enemy projectiles
eproj			db	PROJ_CT*OBJ_LEN dup ?
;eworm			db	ENEMY_CT*WORM_DATA_LEN dup ?
eworm			db	WORM_CT*WORM_DATA_LEN dup ?
eworm_end = $

tmpbuf			dw	?

; Original ROM BIOS interrupt locations
oldint9			dw	?
oldint9s		dw	?
oldpit			dw	?
oldpits			dw	?
