ENEMY_DATA_LEN	= 9
NUMBER_OF_ENEMIES = 27			; this MUST be updated as the enemy
					; table grows

PBOMB_RADIUS = 13
PBOMB_DATA_LEN = PBOMB_RADIUS*4

WORM_DATA_LEN = 4

; Some useful ASCII characters
ASC_EVILHAPPY		= 2
ASC_SMALLBULLET		= 7			; this would be fired by enemies
ASC_HOLLOWBULLET	= 9
ASC_OTHERSTAR		= 15

ASC_FULLBLOCK		= 219
ASC_DARKBLOCK		= 178
ASC_MEDIUMBLOCK		= 177
ASC_LIGHTBLOCK		= 176

; Enemy types (equates)
ENEMY_STUPID		= 1
ENEMY_SUPERSTUPID	= 2
ENEMY_FASTSTUPID	= 3
ENEMY_HYPERSTUPID	= 4

ENEMY_CHASE		= 5
ENEMY_STRONGCHASE	= 6
ENEMY_FASTCHASE		= 7
ENEMY_IRONCHASE		= 8
ENEMY_FRENZYCHASE	= 9
ENEMY_STEELCHASE	= 10
ENEMY_TITANCHASE	= 11
ENEMY_EVILCHASE		= 12

ENEMY_DASH		= 13
ENEMY_SUPERDASH		= 14
ENEMY_BLINKDASH		= 15

ENEMY_GUNNER		= 16
ENEMY_MACHGUNNER	= 17
ENEMY_SHOTGUNNER	= 18
ENEMY_BOUNCEGUNNER	= 19
ENEMY_MOBGUNNER		= 20
ENEMY_RIPPLER		= 21			; Ripplers and lasers are treated as special gunners
ENEMY_TURBOLASER	= 22
ENEMY_DEATHLASER	= 23

ENEMY_WORM		= 24
ENEMY_MODESTWORM	= 25
ENEMY_INSANEWORM	= 26
ENEMY_MEGAWORM		= 27

; Projectile types (default is zero)
PROJ_BOUNCE		= 1
PROJ_RIPPLE		= 2
PROJ_LASER		= 3

; Data for each enemy
; 1 = enemy type (compared against in routines)
; 2 = ticks to move * 16
; 3 = hit points
; 4 = ASCII character
; 5 = ASCII color data
; 6/7 = score awarded for murdering
; 8/9 = depends on what kind of enemy it is

; note: defining more symbols after estupid may be useless

; STUPID - wanders aimlessly
estupid		db	ENEMY_STUPID,		8*16,1,'*',CO_WHITE
		dw	25,rand1		; score, randomness set

; CHASE - follows the player slowly
echase		db	ENEMY_CHASE,		15*16,1,'#',CO_WHITE
		dw	20,0			; last word is always 0 for chase enemies

; SUPERSTUPID - wanders aimlessly, takes more hits
esuperstupid	db	ENEMY_SUPERSTUPID,	10*16,3,'*',CO_GREEN
		dw	45,rand2

; STRONGCHASE - follows the player slowly, takes more hits
		db	ENEMY_STRONGCHASE,	11*16,3,'#',CO_GREEN
		dw	50,0

; DASH - wander, but dash towards the player if line crossed
;	(cannot dash diagonally)
		db	ENEMY_DASH,		9*16,2,ASC_OTHERSTAR,CO_TEAL
		dw	60
		db	55h,0

; FASTCHASE - follows the player kind of fast
		db	ENEMY_FASTCHASE,	9*16,1,'#',CO_TEAL
		dw	75,0

; GUNNER - wanders aimlessly and fires slow bullets
egunner		db	ENEMY_GUNNER,		15*16,1,ASC_EVILHAPPY,CO_WHITE
		dw	120
		db	70h,80h			; bullet speed, shot frequency

; FASTSTUPID - wanders aimlessly very quickly (also takes two hits)
		db	ENEMY_FASTSTUPID,	6*16,2,'*',CO_TEAL
		dw	100,rand4

; IRONCHASE - follows the player slowly, takes a lot of hits
		db	ENEMY_IRONCHASE,	15*16,9,'#',CO_IBLUE
		dw	135,0

; MACHGUNNER - fires faster bullets
		db	ENEMY_MACHGUNNER,	13*16,2,ASC_EVILHAPPY,CO_IBLUE
		dw	160
		db	50h,60h

; WORM - short, slow serpent movement
normalworm	db	ENEMY_WORM,		10*16,5,ASC_FULLBLOCK,CO_IGREEN
		dw	150
		db	4,0			; first byte is length, second is always zero

; SUPERDASH - dash towards player faster
		db	ENEMY_SUPERDASH,	8*16,2,ASC_OTHERSTAR,CO_IPURPLE
		dw	120
		db	44h,0

; FRENZYCHASE - follows the player even faster
		db	ENEMY_FRENZYCHASE,	8*16,1,'#',CO_IPURPLE
		dw	100,0

; MODESTWORM - slightly longer, faster, stronger worm
		db	ENEMY_MODESTWORM,	12*16,7,ASC_FULLBLOCK,CO_IYELLOW
		dw	180
		db	6,0

; SHOTGUNNER - fires at the player in three directions
		db	ENEMY_SHOTGUNNER,	11*16,1,ASC_EVILHAPPY,CO_YELLOW
		dw	175
		db	90h,0A0h

; STEELCHASE - follows the player, takes MANY hits
		db	ENEMY_STEELCHASE,	14*16,16,'#',CO_IBLACK
		dw	220,0

; BOUNCEGUNNER - fires bullets that bounce off walls
		db	ENEMY_BOUNCEGUNNER,	15*16,2,ASC_EVILHAPPY,CO_IGREEN
		dw	185
		db	60h,90h

; INSANEWORM - stubby, fast, trivial worm
		db	ENEMY_INSANEWORM,	6*16,3,ASC_FULLBLOCK,CO_IPURPLE
		dw	200
		db	3,0

; HYPERSTUPID - wanders aimlessly insanely fast, basically having another seizure
		db	ENEMY_HYPERSTUPID,	4*16,1,'*',CO_IPURPLE
		dw	170,rand5

; RIPPLER - fires projectiles that ripple outward
		db	ENEMY_RIPPLER,		14*16,3,ASC_EVILHAPPY,CO_TEAL
		dw	230
		db	80h,0B0h

; MEGAWORM - very long slow worm, strong head prevents skull damage from artillery fire
		db	ENEMY_MEGAWORM,		9*16,12,ASC_FULLBLOCK,CO_ITEAL
		dw	250
		db	7,0

; TITANCHASE - follows player, EXTREMELY durable!!!
		db	ENEMY_TITANCHASE,	15*16,24,'#',CO_IWHITE
		dw	290,0

; TURBOLASER - wanders aimlessly like a gunner, but fires very fast lasers (4-way only)
		db	ENEMY_TURBOLASER,	8*16,3,ASC_EVILHAPPY,CO_ITEAL
		dw	240
		db	40h,0C0h

; BLINKDASH - extreme speed of dash
		db	ENEMY_BLINKDASH,	7*16,4,ASC_OTHERSTAR,CO_ITEAL
		dw	230
		db	33h,0

; EVILCHASE - some hits, very fast, follow player and kill it
		db	ENEMY_EVILCHASE,	7*16,6,'#',CO_RED
		dw	250,0

; MOBGUNNER - extreme machine gun fire rate
		db	ENEMY_MOBGUNNER,	9*16,2,ASC_EVILHAPPY,CO_IYELLOW
		dw	300
		db	40h,50h

; DEATHLASER - can't stop firing so many lasers
		db	ENEMY_DEATHLASER,	7*16,2,ASC_EVILHAPPY,CO_RED
		dw	320
		db	30h,70h

enemylist_end = $

; Force all of the enemies to have the attribute 7 if this is the
; monochrome build.
MONO_ENEMIES

; Various shared enemy behaviors

stupid_movement:
; Make an enemy wander aimlessly.
; Call with:
;	SI = address containing 255 bytes of random data
; Returns: BL
	; Point to a new location in the random data...
	add		si,[rindex]
	; The high byte of rindex is not actually used, it's only there for
	; adding to SI, and is always zero. When the lower byte increments,
	; it wraps around to 0 after 255.
	inc		byte [rindex]
	or		bl,byte [si]
	ret

chase_movement:
; Make an enemy chase the player.
; Call with:
;	DX = enemy location data
; Returns: BL

	; To the right of player?
	cmp		dl,byte [player_x]
	jl		cdchaseleft
	je		cdchaseup
	or		bl,PROJ_LEFT
	jmp		cdchaseup
cdchaseleft:
	je		cdchaseup
	or		bl,PROJ_RIGHT
cdchaseup:
	cmp		dh,byte [player_y]
	jg		cdchasedown
	je		cdchaseend
	or		bl,PROJ_DOWN
	jmp		enemycdend
cdchasedown:
	je		cdchaseend
	or		bl,PROJ_UP
cdchaseend:
	ret

chase_fourway:
; Similar to chase_movement, but only in four directions.
; Call with:
;	DX = enemy location
; Preserves: CX
; Returns: BL
	push		cx
	mov		cx,word [player_x]
	sub		cx,dx
	cmp		cl,ch
	jg		chase4_left
	; We're doing SIGNED operations here
chase4_down:
	cmp		word [player_x],dx		; Anti-infinite loop safety measure
	je		chase4_end
	
	cmp		[player_y],dh
	je		chase4_left
	jl		chase4_up
	or		bl,PROJ_DOWN			; It is move Down
	jmp		chase4_end
chase4_up:
	cmp		cl,dl
	jg		chase4_left
	or		bl,PROJ_UP
	jmp		chase4_end
chase4_left:
	cmp		[player_x],dl
	je		chase4_down
	jg		chase4_right
	or		bl,PROJ_LEFT
	jmp		chase4_end
chase4_right:
	cmp		ch,dh
	jg		chase4_down
	or		bl,PROJ_RIGHT
chase4_end:
	pop		cx
	ret

enemy_shoot:
; Make an enemy shoot a projectile.
; Call with:
;	AL = enemy type
;	DX = enemy position
;	BH = bullet speed
; Preserves: SI
; Destroys: AX, BX, CX
	push		bx
	xor		bl,bl
	cmp		al,ENEMY_RIPPLER
	je		eshoot_fourway
	cmp		al,ENEMY_DEATHLASER
	je		eshoot_fourway
	cmp		al,ENEMY_TURBOLASER
	jne		eshootnormal
eshoot_fourway:
	call		chase_fourway
	jmp		eshootcompare

eshootnormal:
	call		chase_movement

eshootcompare:
	mov		cl,al

	mov		ax,(15*256)+ASC_FULLBLOCK	; Several special enemies use this character for bullets...
eshoot_dlaser:
	cmp		cl,ENEMY_DEATHLASER
	jne		eshoot_tblaser
	or		bl,50h
	jmp		eshootcreate
eshoot_tblaser:
	cmp		cl,ENEMY_TURBOLASER
	jne		eshoot_bounce
	or		bl,30h
	jmp		eshootcreate
eshoot_bounce:
	cmp		cl,ENEMY_BOUNCEGUNNER
	jne		eshoot_ripchar
	mov		al,ASC_HOLLOWBULLET
	or		bl,30h
	jmp		eshootcreate
eshoot_ripchar:
	cmp		cl,ENEMY_RIPPLER
	jne		eshoot_defaultchar
	or		bl,30h
	jmp		eshootcreate
eshoot_defaultchar:
	mov		al,ASC_SMALLBULLET

eshootcreate:
	push		si
	push		cx
	mov		cx,PROJ_CT
	mov		si,eproj-OBJ_LEN
	call		createprojectile
	jnz		eshoot_continue
	mov		[sflags],SESHOOT
	mov		[stimer],0
eshoot_continue:
	pop		cx
	cmp		cl,ENEMY_TURBOLASER		; Set laser type?
	je		eshoot_setlaser
	cmp		cl,ENEMY_DEATHLASER
	jne		eshoot_setbounce
eshoot_setlaser:
	mov		byte [si+6],PROJ_LASER		; Type + 3 trailing squares
	jmp		eshootpreend
eshoot_setbounce:
	cmp		cl,ENEMY_BOUNCEGUNNER		; Set bounce type?
	jne		eshoot_setrip
	mov		byte [si+6],PROJ_BOUNCE
	jmp		eshootpreend
eshoot_setrip:
	cmp		cl,ENEMY_RIPPLER
	jne		eshoot_shotgun
	mov		byte [si+6],PROJ_RIPPLE		; Set ripple type
							; (moveprojectiles will handle rippling)
	jmp		eshootpreend
eshoot_shotgun:
	cmp		cl,ENEMY_SHOTGUNNER
	jne		eshootpreend
	mov		cx,PROJ_CT
	mov		si,eproj-OBJ_LEN
	mov		ah,7
	call		ripple
eshootpreend:
	pop		si
eshootend:
	pop		bx
	ret

dash_movement:
; An enemy dashes towards the player.
; Call with:
;	CL = (dash speed * 16) + dash speed
;	DX = enemy location data
;	SI = address of current enemy
; Returns: BL, ZF
	cmp		dl,byte [player_x]
	jne		dash_horz
	cmp		dh,byte [player_y]
	jg		dash_up
	mov		bl,10h+PROJ_DOWN
	jmp		dash_speedup
dash_up:
	mov		bl,10h+PROJ_UP
	jmp		dash_speedup

dash_horz:
	cmp		dh,byte [player_y]
	jne		dash_end
	cmp		dl,byte [player_x]
	jg		dash_left
	mov		bl,10h+PROJ_RIGHT
	jmp		dash_speedup
dash_left:
	mov		bl,10h+PROJ_LEFT

dash_speedup:
	; Should be modular...
	mov		byte [si+5],cl			; Dash rate is 6 ticks
	mov		[sflags],SEDASH
	mov		[stimer],0

dash_end:
	ret

worm_movement:
; An enemy moves in a similar fashion to the telephone classic "Snake".
; It tries to follow the player, but only has 4-way movement.
; Can only be shot in the head, hence the body is a darker green.
; Call with:
;	CL = body length
;	DX = head location
;	SI = worm head address
; Preserves: BX, SI
; Destroys: AX, CX, DX

	; Initialize some registers
	push		bx
	mov		ax,word [si]
	SET_WORMBODY
	mov		bx,si
	mov		si,eworm-WORM_DATA_LEN

worm_loop:
	add		si,WORM_DATA_LEN
	cmp		si,eworm_end			; If data boundaries exceeded, attempt to add to body
	jae		worm_init_makebody

	cmp		word [si],bx
	jne		worm_loop

	cmp		dx,word [bx+2]			; Don't overwrite the head...
	je		worm_reiterate
	call		setpos
	call		safe_putch

worm_reiterate:
	xchg		dx,word [si+2]			; This value will be used in the next iteration

	; Reiterate until CX = 0
	loop		worm_loop
	jmp		worm_end

worm_init_makebody:
	mov		si,eworm-WORM_DATA_LEN		; Reset source index
worm_makebody:
	add		si,WORM_DATA_LEN
	cmp		si,eworm_end			; If data boundaries exceeded, attempt to add to body
	jae		worm_end

	cmp		word [si],0			; Is this data block EMPTY?
	jnz		worm_makebody

	mov		word [si],bx			; Source enemy
	mov		word [si+2],dx			; New location, should be based on last body part
	; Then leave. Another part will be made in the next tick, if possible.
	;jmp		worm_end2

worm_end:
	cmp		dx,word [bx+2]			; Again, don't overwrite head
	je		worm_end2
	call		setpos
	xor		ax,ax
	call		safe_putch			; Clear out trailing character
worm_end2:
	mov		si,bx
	pop		bx
	ret

wormcollide:
; Check for a collision with worm body.
; Call with:
;	DX = location of current objects
; Returns: ZF (if there was a collision)
; Preserves: AX, SI
	push		si
	mov		si,eworm+2-WORM_DATA_LEN
wormcollide_find:
	add		si,WORM_DATA_LEN
	cmp		si,eworm_end
	jae		wormcollide_invalid

	cmp		dx,word [si]
	jne		wormcollide_find

wormcollide_end:
	jmp		wormcollide_end2
wormcollide_invalid:
	test		dx,dx				; Clear zero flag for invalid object types
wormcollide_end2:
	pop		si
	ret

worm_kill:
; Destroys all data associated with a specific worm.
; Preserves: SI
; Destroys: AX, CX, DX
	;push		cx
	mov		ax,si				; Save the address to match in the worm data
	mov		si,eworm-WORM_DATA_LEN
worm_kill_next:
	add		si,WORM_DATA_LEN
	cmp		si,eworm_end
	jae		worm_kill_garbage

	cmp		ax,word [si]
	jne		worm_kill_next

	; Matched. Kill the worm
	mov		dx,word [si+2]
	mov		word [si],0
	mov		word [si+2],0

	; Delete excess characters from the screen
	call		setpos
	mov		word [es:di],0

	jmp		worm_kill_next

worm_kill_garbage:
	; Garbage collection routine! Pack all worm data to the left.
	; May as well be making an operating system at this rate...
	mov		si,eworm-WORM_DATA_LEN
worm_kill_garbage_loop:
	add		si,WORM_DATA_LEN
	cmp		si,eworm_end
	jae		worm_kill_end

	cmp		word [si],0
	jnz		worm_kill_garbage_loop
	push		si				; Found a free spot. Now save it for later

worm_kill_garbage_collect:
	add		si,WORM_DATA_LEN
	cmp		si,eworm_end
	jae		worm_kill_garbage_terminate	; Out of bounds, unload from stack and get out

	cmp		word [si],0
	jz		worm_kill_garbage_collect

	; Move this data back to the first zeroed address.
	mov		cx,word [si]
	mov		dx,word [si+2]
	mov		word [si],0
	mov		word [si+2],0
	pop		si
	mov		word [si],cx
	mov		word [si+2],dx

	jmp		worm_kill_garbage_loop
	
worm_kill_garbage_terminate:
	pop		si

worm_kill_end:
	mov		si,ax
	;pop		cx
	ret

