#!/usr/bin/env bash
# This is an enemy generation script intended to be executed in Bash.
# It overwrites the waves.asm file with new data for enemies in waves,
# and relies on another file called wave_ecount to get enemy counts for
# each wave.

printf "WAVE_EDATA_LEN\t= 3\n; First byte is the wave number, followed by the total enemy count for\n; the wave (loaded into equeue). After these, the bytes as follows are\n; repeated until the assumed end of the address:\n; 1 = Enemy type\n; 2,3 = Enemy X and Y coordinates\n\n" > waves.asm

enemy_names=( \
	"ENEMY_STUPID" \
	"ENEMY_CHASE" \
	"ENEMY_SUPERSTUPID" \
	"ENEMY_STRONGCHASE" \
	"ENEMY_DASH" \
	"ENEMY_FASTCHASE" \
	"ENEMY_GUNNER" \
	"ENEMY_FASTSTUPID" \
	"ENEMY_IRONCHASE" \
	"ENEMY_WORM" \
	"ENEMY_SUPERDASH" \
	"ENEMY_MACHGUNNER" \
	"ENEMY_FRENZYCHASE" \
	"ENEMY_STEELCHASE" \
	"ENEMY_MODESTWORM" \
	"ENEMY_HYPERSTUPID" \
	"ENEMY_BOUNCEGUNNER" \
	"ENEMY_INSANEWORM" \
	"ENEMY_MEGAWORM" \
	"ENEMY_SHOTGUNNER" \
	"ENEMY_TITANCHASE" \
	"ENEMY_TURBOLASER" \
	"ENEMY_BLINKDASH" \
	"ENEMY_RIPPLER" \
	"ENEMY_EVILCHASE" \
	"ENEMY_MOBGUNNER" \
	"ENEMY_DEATHLASER" \
)

# Update wcount as the game grows
wcount=24

x_max=38
y_max=23

for ((wave=1; wave<=$wcount; ++wave)); do
	ecount=$(awk "NR==$wave{print \$0}" wave_ecount.txt)
	#erange=$[2+$wave]
	erange=3+$[$wave-1]
	printf "wave$wave\tdb\t$wave,$ecount,\t\\\\\n" >> waves.asm
	#for enemy in {1..$[$ecount-1]}; do
	for ((enemy=1; enemy<=$[$ecount-1];++enemy)); do
		RANDOM=$(date +%s%N | cut -b10-19)
		printf "\t\t${enemy_names[$[$RANDOM % $erange]]},$[$RANDOM % $x_max + 2],$[$RANDOM % $y_max + 2],\t\t\\\\\n" >> waves.asm
	done
	# Last one cannot end on a comma!
	printf "\t\t${enemy_names[$[$RANDOM % $erange]]},$[$RANDOM % $x_max + 2],$[$RANDOM % $y_max + 2]\n" >> waves.asm
done

# Wave 25 data
printf 'LAST_WAVE_ADDR = $' >> waves.asm
printf "wave25\tdb\t25,255,\t\\\\\n" >> waves.asm
erange=27
for i in {1..254}; do
	RANDOM=$(date +%s%N | cut -b10-19)
	printf "\t\t${enemy_names[$[$RANDOM % $erange]]},$[$RANDOM % $x_max + 2],$[$RANDOM % $y_max + 2],\t\t\\\\\n" >> waves.asm
done
	printf "\t\tENEMY_DEATHLASER,32,8\n" >> waves.asm
