macro HUDCOLOR {
if MONO_TRUE = 1
	mov		ax,0700h
else
	mov		ax,1F00h
end if
}

macro GREENHUD {
if MONO_TRUE = 0
	cmp		[wave],LAST_WAVE
	jne		hudbar
	mov		ah,2Fh
end if
}

macro REDHUD {
if MONO_TRUE = 1
	mov		al,70h
else
	mov		al,4Fh
end if
}

macro TIMEOUT_COLOR {
; Turns out one value works for both modes.
	mov	byte [si+1],12
}

macro SAFE_PUTCH {
if MONO_TRUE = 1
	stosw
else
	push		dx
	push		bx
	mov		bx,ax
	mov		dx,3DAh
.safe_hsync:
	in		al,dx
	test		al,1
	jnz		.safe_hsync
.safe_retrace:
	in		al,dx
	shr		al,1
	jnc		.safe_retrace
	mov		ax,bx				; Has to be done this way for minimal cycles wasted!
	stosw
	pop		bx
	pop		dx
end if
}

macro WAVEMSG_FLICKER {
if MONO_TRUE = 1
	xor		ah,8
else
	inc		ah
	cmp		ah,8
	jb		wavemsg_finishborder
	mov		ah,1
end if
}

macro SHLEXTRA {
if X_MAX = 80
	shl		ax,1
end if
}

macro TITLE_BORDER {
if MONO_TRUE = 1
	mov		ah,7
else
	mov		ah,14
end if
}

macro WAVE_BORDER {
if MONO_TRUE = 1
	mov		ah,7
else
	mov		ah,15
end if
}

macro POTENTIAL_TEXT {
if MONO_TRUE = 1
	mov		ah,4
else
	mov		ah,1
end if
}

macro MONO_ENEMIES {
if MONO_TRUE = 1
CO_BLUE		= 7
CO_GREEN	= 7
CO_TEAL		= 7
CO_RED		= 7
CO_PURPLE	= 7
CO_YELLOW	= 7
CO_WHITE	= 7
CO_IBLACK	= 7
CO_IBLUE	= 7
CO_IGREEN	= 7
CO_ITEAL	= 7
CO_IRED		= 7
CO_IPURPLE	= 7
CO_IYELLOW	= 7
CO_IWHITE	= 7
else
CO_BLUE		= 1
CO_GREEN	= 2
CO_TEAL		= 3
CO_RED		= 4
CO_PURPLE	= 5
CO_YELLOW	= 6		; often brown
CO_WHITE	= 7
CO_IBLACK	= 8
CO_IBLUE	= 9
CO_IGREEN	= 10
CO_ITEAL	= 11
CO_IRED		= 12
CO_IPURPLE	= 13
CO_IYELLOW	= 14		; often brown
CO_IWHITE	= 15
end if
}

macro SET_WORMBODY {
if MONO_TRUE = 1
	mov		al,ASC_DARKBLOCK	; slightly unshaded blocks indicate the body
else
	sub		ah,8			; source color must always be intense
end if
}

macro HIT_COLOR {
if MONO_TRUE = 1
	mov		ah,70h
else
	mov		ah,4
end if
}
