; WASD keys (for firing)
KEY_W		= 11h
KEY_A		= 1Eh
KEY_S		= 1Fh
KEY_D		= 20h

; P key (for pausing)
KEY_P		= 19h

; M key (for muting/unmuting)
KEY_M		= 32h

; Space key (detonate a bomb)
KEY_SPACE	= 39h

; Arrow keys (for moving)
KEY_UP		= 48h
KEY_LEFT	= 4Bh
KEY_RIGHT	= 4Dh
KEY_DOWN	= 50h
KEY_DOWN_ALT	= 4Ch		; 5 on keypad, for XT keyboard users

; -- PIT handler --
pithandler:
	cli
	inc		[gtimer]
	add		[oldtimer],PIT_FREQ/PIT_DIV
	jnc		ackpit
	jmp		dword [oldpit]
	jmp		pitend

ackpit:
	; Interrupt acknowledge
	push		ax
	mov		al,20h
	out		20h,al
	pop		ax
	
pitend:
	sti
	iret
; -- End of PIT handler --

readkey: ; -- Start of procedure --
	cli
	pushf
	push	ax
	; Read the keystroke and process it
	in		al,60h
	
	; note: change this all to normal individual compares, no fancy counter
	
testrelease:
	; Is the scan code above 80h? This would indicate the key was released.
	; (This helps save some cycles)
	test		al,80h
	jz		mutecheck
	jmp		keyreleased

; I had a nice, clean CX looping ritual here before, but it was making key
; rollover less responsive, so I ended up going with this shit instead.
mutecheck:
	cmp		al,KEY_M
	jne		pausecheck
	or		[otherkeys],8
	jmp		ackread2
pausecheck:
	cmp		al,KEY_P
	jne		spacecheck
	or		[otherkeys],4
	jmp		ackread2
spacecheck:
	cmp		al,KEY_SPACE
	jne		khw
	or		[otherkeys],2
	jmp		ackread2
	
khw:
	; Key pressed?
	cmp		al,KEY_W
	jne		kha
	or		[moveshootkeys],HKEY_W
	jmp		ackread2
kha:
	cmp		al,KEY_A
	jne		khs
	or		[moveshootkeys],HKEY_A
	jmp		ackread2
khs:
	cmp		al,KEY_S
	jne		khd
	or		[moveshootkeys],HKEY_S
	jmp		ackread2
khd:
	cmp		al,KEY_D
	jne		khup
	or		[moveshootkeys],HKEY_D
	jmp		ackread2
khup:
	cmp		al,KEY_UP
	jne		khleft
	or		[moveshootkeys],HKEY_UP
	jmp		ackread2
khleft:
	cmp		al,KEY_LEFT
	jne		khright
	or		[moveshootkeys],HKEY_LEFT
	jmp		ackread2
khright:
	cmp		al,KEY_RIGHT
	jne		khdown
	or		[moveshootkeys],HKEY_RIGHT
	jmp		ackread2
khdown:
	cmp		al,KEY_DOWN_ALT
	je		khdownack
	cmp		al,KEY_DOWN
	je		khdownack
	jmp		ackread
khdownack:
	or		[moveshootkeys],HKEY_DOWN
	jmp		ackread2

keyreleased:
	cmp		al,KEY_M+80h
	jne		prel
	and		[otherkeys],not 8
	jmp		ackread2
prel:
	cmp		al,KEY_P+80h
	jne		sprel
	and		[otherkeys],not 4
	jmp		ackread2
sprel:
	cmp		al,KEY_SPACE+80h
	jne		krw
	and		[otherkeys],not 2
	jmp		ackread2
krw:
	; Key released?
	cmp		al,KEY_W+80h
	jne		kra
	and		[moveshootkeys],not HKEY_W
	jmp		ackread2
kra:
	cmp		al,KEY_A+80h
	jne		krs
	and		[moveshootkeys],not HKEY_A
	jmp		ackread2
krs:
	cmp		al,KEY_S+80h
	jne		krd
	and		[moveshootkeys],not HKEY_S
	jmp		ackread2
krd:
	cmp		al,KEY_D+80h
	jne		krup
	and		[moveshootkeys],not HKEY_D
	jmp		ackread2
krup:
	cmp		al,KEY_UP+80h
	jne		krleft
	and		[moveshootkeys],not HKEY_UP
	jmp		ackread2
krleft:
	cmp		al,KEY_LEFT+80h
	jne		krright
	and		[moveshootkeys],not HKEY_LEFT
	jmp		ackread2
krright:
	cmp		al,KEY_RIGHT+80h
	jne		krdown
	and		[moveshootkeys],not HKEY_RIGHT
	jmp		ackread2
krdown:
	cmp		al,KEY_DOWN_ALT+80h
	je		krdownack
	cmp		al,KEY_DOWN+80h
	jne		ackread2
krdownack:
	and		[moveshootkeys],not HKEY_DOWN
	jmp		ackread2

ackread:
	cmp		al,1		; press ESC to exit
	jne		ackread2
	; Set some memory index and jump to ackread
	or		[otherkeys],1
ackread2:
	; not sure what this does
	in		al,61h
	or		al,80h
	out		61h,al
	xor		al,80h
	out		61h,al
	; Acknowledge the interrupt very dumbly
	mov		al,20h
	out		20h,al
	
	; Restore registers
	pop		ax
	popf
	sti
	iret
; -- End of readkey procedure --

;keys	db	KEY_W,KEY_A,KEY_S,KEY_D,							\	; Key pressed
			;KEY_UP,KEY_LEFT,KEY_RIGHT,KEY_DOWN,					\
			;KEY_W+80h,KEY_A+80h,KEY_S+80h,KEY_D+80h,			\	; Key released
			;KEY_UP+80h,KEY_LEFT+80h,KEY_RIGHT+80h,KEY_DOWN+80h
